Python 3.7.3 (default, Sep 19 2023, 08:52:39) 
[GCC 8.3.0] on linux
Type "help", "copyright", "credits" or "license()" for more information.
>>> from collections import deque, defaultdict
>>> 
>>> def find_guarded_warehouses(n, m, k, roads, guards):
	# Создаем граф
	graph = defaultdict(list)
	for a, b in roads:
		graph[a].append(b)
		graph[b].append(a)
	# Множество для хранения охраняемых складов
	guarded = set()
	# Обрабатываем каждого охранника
	for p, h in guards:
		# BFS для нахождения охраняемых складов
		queue = deque([(p, 0)])  # (текущий склад, расстояние)
		visited = set()
		visited.add(p)
		while queue:
			current, distance = queue.popleft()
			if distance <= h:
				guarded.add(current)
				for neighbor in graph[current]:
					if neighbor not in visited:
						visited.add(neighbor)
						queue.append((neighbor, distance + 1))
	# Подготовка результата
	guarded_list = sorted(guarded)
	return len(guarded_list), guarded_list
# Чтение входных данных
n, m, k = map(int, input().split())
SyntaxError: invalid syntax
>>> roads = [tuple(map(int, input().split())) for _ in range(m)]
Traceback (most recent call last):
  File "<pyshell#30>", line 1, in <module>
    roads = [tuple(map(int, input().split())) for _ in range(m)]
NameError: name 'm' is not defined
>>> guards = [tuple(map(int, input().split())) for _ in range(k)]
Traceback (most recent call last):
  File "<pyshell#31>", line 1, in <module>
    guards = [tuple(map(int, input().split())) for _ in range(k)]
NameError: name 'k' is not defined
>>> # Получение охраняемых складов
>>> count, guarded_warehouses = find_guarded_warehouses(n, m, k, roads, guards)
Traceback (most recent call last):
  File "<pyshell#33>", line 1, in <module>
    count, guarded_warehouses = find_guarded_warehouses(n, m, k, roads, guards)
NameError: name 'find_guarded_warehouses' is not defined
>>> # Вывод результата
>>> print(count)
Traceback (most recent call last):
  File "<pyshell#35>", line 1, in <module>
    print(count)
NameError: name 'count' is not defined
>>> print(" ".join(map(str, guarded_warehouses)))

Traceback (most recent call last):
  File "<pyshell#36>", line 1, in <module>
    print(" ".join(map(str, guarded_warehouses)))
NameError: name 'guarded_warehouses' is not defined
>>> 
